<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for DepthFirstSearch.
 * Generated by PHPUnit on 2012-07-03 at 17:01:23.
 * @group directory_iterators
 */
class DepthFirstSearchTest extends \PHPUnit_Framework_TestCase {

    /** @var DepthFirstSearch */
    private $iterator;
    private $filenamesFromDir;

    protected function setUp() {
        $this->iterator = new DepthFirstSearch(TEMP_FILEDIR);
        $this->filenamesFromDir = array(
            0 => array(
                'temp-files'
            ),
            1 => array(
                'existing', 'existing-žeš', 'test',
                'existing.php', 'existing-žeš.php', 'test.php'
            ),
            2 => array(
                'index.php', 'ošel'
            ),
        );
    }

    public function testIterator() {
        $count = 0;
        $lastDepth = 0;
        $lastDirPath = '';
        while ($this->iterator->hasNext()) {
            $next = $this->iterator->next();
            $filename = \Treewec\FileSystem\Path::toScreen($next->splFileInfo->getFilename());
            if ($filename != 'dir.order') {
                parent::assertTrue(in_array($filename, $this->filenamesFromDir[$next->depth]));
                // test - previous dir is parent dir of current file
                if ($lastDirPath && $lastDepth < $next->depth) {
                    parent::assertTrue($next->splFileInfo->getPath() == $lastDirPath);
                }
            
                $lastDepth = $next->depth;
                if ($next->splFileInfo->isDir()) {
                    $lastDirPath = $next->splFileInfo->getPathname();
                }
                $count++;
            }
        }
        parent::assertEquals($count, $this->getStaticCount());
    }

    private function getStaticCount() {
        $count = 0;
        foreach ($this->filenamesFromDir as $names) {
            $count += count($names);
        }
        return $count;
    }

}

?>
